package cn.estsh.i3plus.core.apiservice.mq;

import com.rabbitmq.client.Channel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Component;

import java.io.IOException;

/**
 * @Description : 定时任务通道业务处理
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2018-12-20 21:56
 * @Modify:
 **/
@Component
public class WYHQueueReceiver {

    private static final Logger LOGGER = LoggerFactory.getLogger(WYHQueueReceiver.class);


    /**
     * 定时任务通道处理
     *
     * @param data      系统消息信息
     * @param channel   通道
     * @param message   消息
     */
    @RabbitListener(queues = "WYH")
    public void processSchedule(String data, Channel channel, Message message) {
        try {
            System.out.println("队列消息接受成功========" + data);
            //信息已处理
            channel.basicAck(message.getMessageProperties().getDeliveryTag(), false);
        } catch (IOException e) {
            LOGGER.error("【MQ-IMPP_MESSAGE_MAIL_QUEUE】处理出错：{}", e.getMessage(), e);
            //丢弃这条消息
            try {
                // 未成功处理，重新发送
                channel.basicNack(message.getMessageProperties().getDeliveryTag(), false, true);
            } catch (IOException e1) {
                e1.printStackTrace();
            }
        }
    }
}
